org.apache.struts2.jasper.compiler

## Class SmapUtil

- java.lang.Object
- - org.apache.struts2.jasper.compiler.SmapUtil

-     public class SmapUtil
      extends Object

  Contains static utilities for generating SMAP data based on the current version of Jasper.
  Author:
    Jayson Falkner, Shawn Bayern, Robert Field (inner SDEInstaller class), Mark Roth, Kin-man Chung

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static String` | `SMAP_ENCODING`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `SmapUtil()`

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `static void` | `evaluateNodes(Node.Nodes nodes, SmapStratum s, HashMap innerClassMap, boolean breakAtLF)`
    `static String[]` | `generateSmap(JspCompilationContext ctxt, Node.Nodes pageNodes)` Generates an appropriate SMAP representing the current compilation context.
    `static void` | `installSmap(String[] smap)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### SMAP_ENCODING

          public static final String SMAP_ENCODING

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### SmapUtil

          public SmapUtil()

  - ### Method Detail

    - #### generateSmap

          public static String[] generateSmap(JspCompilationContext ctxt,
                                              Node.Nodes pageNodes)
                                       throws IOException

      Generates an appropriate SMAP representing the current compilation context. (JSR-045.)
      Parameters:
        `ctxt` - Current compilation context
        `pageNodes` - The current JSP page
      Returns:
        a SMAP for the page
      Throws:
        `IOException` - in case of IO errors

    - #### installSmap

          public static void installSmap(String[] smap)
                                  throws IOException

      Throws:
        `IOException`

    - #### evaluateNodes

          public static void evaluateNodes(Node.Nodes nodes,
                                           SmapStratum s,
                                           HashMap innerClassMap,
                                           boolean breakAtLF)

Copyright © 2000–2025 Apache Software Foundation. All rights reserved.